<template>
  <div class="zxReturn pagePadding">
    <div
      v-if="powers && powers.length > 0 && powers.some((item) => item == '001')"
    >
      <ex-table
        v-loading="loading"
        :table="table"
        :data="tableData"
        :columns="columns"
        :page="pageInfo"
        :size="size"
        @page-curr-change="handlePageChange"
        @page-size-change="handleSizeChange"
        @screen-reset="
          pageInfo.curr = 1;
          parmValue.page = 1;
          searchList();
        "
        @screen-submit="
          pageInfo.curr = 1;
          parmValue.page = 1;
          searchList();
        "
      >
        <template #table-header="{}">
          <div style="width: 100%">
            <el-row style="padding: 0 0 0 80px">
              <el-col :span="4" style="width: 170px">
                <el-select
                  :size="searchSize"
                  v-model="parmValue.status"
                  filterable
                  clearable
                  placeholder="退货单状态"
                  style="width: 100%"
                  @change="
                    pageInfo.curr = 1;
                    parmValue.page = 1;
                    searchList();
                  "
                >
                  <el-option
                    v-for="item in statusOptions"
                    :key="'status' + item.id"
                    :label="item.label"
                    :value="item.id"
                  />
                </el-select>
              </el-col>
              <!-- 时间区间 -->
              <el-col :span="6" style="width: 303px; padding: 0 0 0 10px">
                <period-date-picker
                  :type="1"
                  :width="'135px'"
                  :size="searchSize"
                  :start="parmValue.start"
                  :end="parmValue.end"
                  @timeReturned="handleTime"
                />
              </el-col>

              <el-col :span="3" style="width: 66px; float: right">
                <el-button
                  :size="searchSize"
                  type="primary"
                  style="float: right; margin-left: 5px"
                  @click="searchList"
                >
                  刷新
                </el-button>
              </el-col>
            </el-row>
            <el-row style="padding: 10px 0 0 0">
              <el-col :span="6" style="width: 450px">
                <el-input
                  placeholder="关键字"
                  v-model="s_input"
                  :size="searchSize"
                  class="input-with-select"
                >
                  <el-select
                    v-model="select"
                    style="width: 125px"
                    slot="prepend"
                    placeholder="请选择"
                  >
                    <el-option label="退货单编号" value="1" />
                    <el-option label="咨询订单编号" value="2" />
                    <el-option label="申请人" value="3" />
                  </el-select>
                  <el-button
                    slot="append"
                    icon="el-icon-search"
                    @click="
                      pageInfo.curr = 1;
                      parmValue.page = 1;
                      searchList();
                    "
                  ></el-button>
                </el-input>
              </el-col>
              <el-col :span="4" style="width: 66px; float: right">
                <el-button
                  type="warning"
                  class="fr"
                  :size="searchSize"
                  @click="restSearch"
                >
                  重置
                </el-button>
              </el-col>
            </el-row>
          </div>
        </template>
        <template #status="{ scope }">
          <el-tag
            :size="tablebtnSize"
            :type="scope.row.status == '0' ? 'warning' : ''"
            v-text="
              (statusOptions.find((item) => item.id == scope.row.status) || {})
                .label || '--'
            "
          ></el-tag>
        </template>
        <template #operation="{ scope }">
          <el-tooltip
            v-if="powers.some((item) => item == '007')"
            effect="dark"
            content="详情"
            placement="top"
          >
            <i
              class="el-icon-view tb-icon"
              @click="routeGoto('zxReturnDetail', { id: scope.row.returnCode })"
            ></i>
          </el-tooltip>
        </template>
      </ex-table>
      <add-edit
        :id="modelId"
        :sitem="sitem"
        :show-model="showModel"
        :is-detail="isDetail"
        @refresh="searchList"
        @cancel="showModel = false"
      />
    </div>
    <div v-else>
      <no-auth></no-auth>
    </div>
  </div>
</template>
   <script>
import mixinPage from "@/mixins/elPaginationHandle";
import resToken from "@/mixins/resToken";
import columns from "./columns";
import asyncRequest from "@/apis/service/sellOut/zxReturn";
import addEdit from "./addEdit";
import { mapGetters } from "vuex";

export default {
  name: "zxReturn",
  mixins: [mixinPage, resToken],
  components: {
    addEdit,
  },
  computed: {
    ...mapGetters(["tablebtnSize", "searchSize", "size"]),
    powers() {
      let tran =
        this.$store.getters.btnList.find(
          (item) => item.menu_route == "zxReturn"
        ) || {};
      if (tran && tran.action && tran.action.length > 0) {
        return tran.action;
      } else {
        return [];
      }
    },
  },
  data() {
    return {
      select: "1",
      s_input: "",
      sitem: null,
      // 状态
      statusOptions: [
        { id: "0", label: "待业务部门审核" },
        { id: "1", label: "待告知业务部门" },
        { id: "2", label: "待告知财务部门" },
        { id: "3", label: "退货已完成" },
      ],
      loading: true,
      showModel: false,
      isDetail: false,
      modelId: 0,
      parmValue: {
        order_type: "2",
        returnCode: "", //采购单号
        orderCode: "", //退货单编号
        apply_name: "", //申请人
        start: "",
        end: "",
        status: "", //节点状态
        page: 1, // 页码
        size: 15, // 每页显示条数
      },
      tableData: [],
      passwordModel: false,
      passwordModelId: 0,
      isPasswordDetail: false,
      // 表格 - 数据
      tableData: [],
      // 表格 - 参数
      table: {
        stripe: true,
        border: true,
        _defaultHeader_: ["setcol"],
      },
      // 表格 - 分页
      pageInfo: {
        size: 15,
        curr: 1,
        total: 0,
      },
      // 表格 - 列参数
      columns: columns,
    };
  },
  mounted() {
    this.searchList();
  },

  methods: {
    restSearch() {
      this.s_input = "";
      this.select = "1";
      this.parmValue = {
        order_type: "2",
        returnCode: "", //采购单号
        orderCode: "", //退货单编号
        returnStoreNum: "", //退货仓库编号
        returnCompanyNum: "", //退货公司编号
        apply_name: "", //申请人
        start: "",
        end: "",
        status: "", //节点状态
        page: 1, // 页码
        size: 15, // 每页显示条数
      };
      // 表格 - 分页
      this.pageInfo = {
        size: 15,
        curr: 1,
        total: 0,
      };
      this.searchList();
    },

    openModal(id, isDetail, sitem) {
      this.showModel = true;
      this.modelId = id;
      this.isDetail = isDetail;
      this.sitem = sitem;
    },

    async searchList() {
      this.loading = true;
      let model = JSON.parse(JSON.stringify(this.parmValue));
      model.returnCode = this.select === "1" ? this.s_input : "";
      model.orderCode = this.select === "2" ? this.s_input : "";
      model.apply_name = this.select === "3" ? this.s_input : "";
      const res = await asyncRequest.list(model);
      if (res && res.code === 0 && res.data) {
        this.tableData = res.data.list;
        this.pageInfo.total = Number(res.data.count);
      } else if (res && res.code >= 100 && res.code <= 104) {
        await this.logout();
      } else {
        this.tableData = [];
        this.pageInfo.total = 0;
      }
      this.loading = false;
    },

    async statusConfirm(id, status) {
      let str = status === "1" ? "禁用" : "启用";
      await this.$confirm("确定要改为" + str + "?", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          this.loading = true;
          const model = {
            id: id,
            status: status === "1" ? "0" : "1",
          };
          const res = await asyncRequest.status(model);
          if (res && res.code === 0) {
            this.loading = false;
            this.$notify.success({
              title: "状态修改成功！",
              message: "",
            });
            await this.searchList();
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    //物流公司查询
    async handleCompany(e) {
      console.log(e, "要求传快递简称，不传id"); //
      if (e && e.code) {
        this.parmValue.postCompany = [e.shortName];
        this.parmValue.page = 1;
      }
      await this.searchList();
    },
  
  },
};
</script>
   <style lang="scss" scoped>
.zxReturn {
}
</style>
   